//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property link "http://www.forex-instruments.info"
//+------------------------------------------------------------------+
//|                                                   AMA&AMAsig.mq4 |                                                             
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, by GOODMAN & Mstera  AF www.expforex.com edit AlertArrow"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Sienna
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Gold

//---- input parameters
extern int       periodAMA=9;
extern int       nfast=2;
extern int       nslow=30;
extern double    G=2.0;
extern double    dK=2.0;

//---- buffers
double kAMAbuffer[];
double kAMAupsig[];
double kAMAdownsig[];
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
extern string Alerts="    www.expforex.com";
extern bool AlerT=true;  //              
extern bool Mail=true;   //           
extern bool Push=true;   //    
extern bool Arrow=true;  //    
extern int shift=1;      //      0 -   1 -  
int timeee;              //  
string nameInd;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetArrow(int cd,color cl,
              string nm="",datetime t1=0,double p1=0,int sz=3)
  {
   if(nm=="") nm=DoubleToStr(Time[0],0);
   if(t1<=0) t1=Time[0];
   if(p1<=0) p1=Bid;
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
   wind=0;
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_ARROW,wind,0,0);
   ObjectSet(nm,OBJPROP_TIME1,t1);
   ObjectSet(nm,OBJPROP_PRICE1,p1);
   ObjectSet(nm,OBJPROP_ARROWCODE,cd);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_WIDTH,sz);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Expforex_AlertArrow(string text="",int arrowdir=0,bool history=false,int i=0)
  {
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
   if(wind==-1)wind=0;
   ObjectCreate("Originalalert",OBJ_LABEL,wind,0,0);
   ObjectSetText("Originalalert"," AlertArrow www.expforex.com",10,"Arial Bold",Red);
   ObjectSet("Originalalert",OBJPROP_CORNER,2);
   ObjectSet("Originalalert",OBJPROP_XDISTANCE,200);
   ObjectSet("Originalalert",OBJPROP_YDISTANCE,10);
   if(!history)
     {
      if(AlerT) Alert(text);
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shift],0),Time[shift],Low[shift]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shift],0),Time[shift],High[shift]);
      if(!IsTesting())if(Mail) SendMail(text,text);
      if(!IsTesting())if(Push) SendNotification(text);
     }
   if(history)
     {
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shift+i],0),Time[shift+i],Low[shift+i]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shift+i],0),Time[shift+i],High[shift+i]);

     }

  }

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+

//+------------------------------------------------------------------+

int    cbars=0,prevbars=0,prevtime=0;

double slowSC,fastSC;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
//SetIndexDrawBegin(0,nslow+nfast);
   SetIndexBuffer(0,kAMAbuffer);
   SetIndexBuffer(1,kAMAupsig);
   SetIndexBuffer(2,kAMAdownsig);

   IndicatorDigits(4);

//slowSC=0.064516;
//fastSC=0.2;
//cbars=IndicatorCounted();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i,pos=0;
   double noise=0.000000001,AMA,AMA0,signal,ER;
   double dSC,ERSC,SSC,ddK;

   if(prevbars==Bars) return(0);

//---- TODO: add your code here
   slowSC=(2.0 /(nslow+1));
   fastSC=(2.0 /(nfast+1));
   cbars=IndicatorCounted();
   if(Bars<=(periodAMA+2)) return(0);
//---- check for possible errors
   if(cbars<0) return(-1);
//---- last counted bar will be recounted
   if(cbars>0) cbars--;
   pos=Bars-periodAMA-2;
   AMA0=Close[pos+1];
   while(pos>=0)
     {
      if(pos==Bars-periodAMA-2) AMA0=Close[pos+1];
      signal=MathAbs(Close[pos]-Close[pos+periodAMA]);
      noise=0.000000001;
      for(i=0;i<periodAMA;i++)
        {
         noise=noise+MathAbs(Close[pos+i]-Close[pos+i+1]);
        };
      ER =signal/noise;
      dSC=(fastSC-slowSC);
      ERSC=ER*dSC;
      SSC=ERSC+slowSC;
      AMA=AMA0+(MathPow(SSC,G)*(Close[pos]-AMA0));
      kAMAbuffer[pos]=AMA;

      ddK=(AMA-AMA0);
      if((MathAbs(ddK))>(dK*Point)  && (ddK>0)) kAMAupsig[pos]=AMA; else kAMAupsig[pos]=0;
      if((MathAbs(ddK))>(dK*Point) &&(ddK<0)) kAMAdownsig[pos]=AMA; else kAMAdownsig[pos]=0;


      AMA0=AMA;
      pos--;
     };
//----
   prevbars=Bars;

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   nameInd=WindowExpertName();

   int sig=0;
   int signaler=0;
   int kolbuy=0;
   int kolsell=0;
   for(int o=shift;o<=shift+100;o++)
     {

      if(kAMAupsig[o]!=0){kolbuy++;kolsell=0;}
      if(kAMAdownsig[o]!=0){kolsell++;kolbuy=0;}

      if(kolbuy==2){sig=1;break;}
      if(kolsell==2){sig=2;break;}

     }

   for(int r=o+1;r<=o+100;r++)
     {

      if(sig==1 && kAMAdownsig[r]!=0){signaler=1;break;}
      if(sig==2 && kAMAupsig[r]!=0){signaler=2;break;}
      if(sig==1 && kAMAupsig[r]!=0){signaler=0;break;}
      if(sig==2 && kAMAdownsig[r]!=0){signaler=0;break;}

     }

   if(timeee!=Time[0] && signaler==1)
     {
      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP",1);
      timeee=Time[0];
     }

   if(timeee!=Time[0] && signaler==2)
     {
      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN",2);
      timeee=Time[0];
     }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+




   return(0);
  }
//+------------------------------------------------------------------+
